

import javax.annotation.Resource;
import javax.ejb.Stateful;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.PersistenceContextType;
import javax.transaction.UserTransaction;

@Stateful
@TransactionManagement(TransactionManagementType.BEAN)
public class EmployeeBean implements EmployeeServiceLocal, EmployeeServiceRemote {
  @PersistenceContext(unitName = "EmployeeService", type = PersistenceContextType.EXTENDED)
  private EntityManager em;

  @Resource
  private UserTransaction ut;
  
  public EmployeeBean() {
  }


  public void doAction() {
    Employee emp = new Employee();
    emp.setFirstName("first");
    em.persist(emp);

  }
  public <T> T mergeEntity(T entity) {
    return em.merge(entity);
  }

  public <T> T persistEntity(T entity) {
    em.persist(entity);
    return entity;
  }

  public <T> T refreshEntity(T entity) {
    em.refresh(entity);
    return entity;
  }

  public void removeEntity(Object entity) {
    em.remove(em.merge(entity));
  }
  public void beginTrans()
    throws Exception {
    ut.begin();
  }

  public void commitTrans()
    throws Exception {
    ut.commit();
  }

  public void rollbackTrans()
    throws Exception {
    ut.rollback();
  }
}
